// $Id: UnhandledException.java,v 1.1 2003/02/25 01:35:43 lw Exp $
package team5.base;

/**
 * This class represents an unhandled exception. An unhandled exception
 * can be used at development time to indicate that some exception handling
 * has to be added to the code.
 * @author Team 5
 * @version $Revision: 1.1 $
 */
public class UnhandledException extends RuntimeException {

    /**
     * Constructs a new exception with <code>null</code> as its detail message.
     */
    public UnhandledException() {
        super();
    }

    /**
     * Constructs a new exception with the specified detail message.
     * @param   message   the detail message.     */
    public UnhandledException(String message) {
        super(message);
    }

    /**
     * Constructs a new exception with the specified detail message and
     * cause.
     * @param  message the detail message
     * @param  cause the cause
     */
    public UnhandledException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * Constructs a new exception with the specified cause and a detail
     * message of <tt>(cause==null ? null : cause.toString())</tt>.
     */
    public UnhandledException(Throwable cause) {
        super(cause);
    }
}
