// $Id: ObjectID.java,v 1.2 2003/02/27 02:39:23 lw Exp $
package team5.base.comm;

import team5.base.comm.DuplicateValueException;

/**
 * This class holds an immutable object id value.
 *
 * @author Team 5
 * @version $Revision: 1.2 $
 */
public final class ObjectID {

    public static void setOID(int oid) throws DuplicateValueException {

        if (ObjectID.oid != 0) {
            throw new DuplicateValueException("Object ID already set to " + oid);
        }
        ObjectID.oid = oid;
    }

    public static int getOID() {

        return oid;
    }


    // Private methods

    /**
     * No object of this class should be created.
     */
    private ObjectID() {
    }

    // Fields

    private static int oid = 0;
}
