// $Id: SequenceNumber.java,v 1.2 2003/03/06 18:19:08 lw Exp $
package team5.base.comm;

/**
 * This class generates integer sequence numbers.
 * @author Team 5
 * @version $Revision: 1.2 $
 */
public class SequenceNumber {

    /**
     * Get the next sequence number. The counter starts with 1 and wraps around
     * if <code>Integer.MAX_VALUE</code>.
     * @return the next number
     */
    public synchronized static int next() {

        if (lastValue == Integer.MAX_VALUE) {
            lastValue = 0;
        }
        return ++lastValue;
    }

    private static int lastValue = 0;
}

