// $Id: CardDeck.java,v 1.3 2003/02/23 21:27:41 etwilson Exp $
package team5.base.game;

import java.util.*;

/**
 * A class to encapsulate the atributes of a a poker card Deck
 */
public class CardDeck {

    Vector cards;
    Random rand;
    Card temp;
    static final int SHUFFLES = 1000;

    public static void main(String[] args) {

        CardDeck cd = new CardDeck();
        System.out.println("An un-shuffled deck:");

        try {
            while (true) {

                System.out.print("\"" + cd.nextCard().getName() + "\"  ");
            }
        } catch (ArrayIndexOutOfBoundsException e) {
        }

        cd = new CardDeck();
        cd.shuffle();

        System.out.println("\nAn un-shuffled deck:");
        try {
            while (true) {

                System.out.print("\"" + cd.nextCard().getName() + "\"  ");
            }
        } catch (ArrayIndexOutOfBoundsException e) {
        }
        System.out.println();
    }
    /**
    * The constructer for the class. 
    */
    CardDeck() {

        rand = new Random(); //Seeded with time of day
        cards = new Vector(Card.MAXVAL);

        for (byte b = 0; b < Card.MAXVAL + 1; b++) {

            cards.addElement(new Card(b));
        }
    }
    /**
    * Shuffle the deck ramdomly switching cards for SHUFFLES number of times.
    */
    public void shuffle() {

        int pos;
        for (int i = 0; i < SHUFFLES; i++) {

            pos = rand.nextInt(cards.size());
            temp = (Card) cards.remove(pos);
            cards.addElement(temp);
        }
    }
    /**
    * Get all the cards left in the deck
    */
    public Card[] getCards() {

        return (Card[]) cards.toArray();
    }
    /**
    * Get the next card in the deck removing is from the deck.
    */
    public Card nextCard() {

        return (Card) cards.remove(0);
    }

}






