// $Id: ShutdownThread.java,v 1.2 2003/03/06 18:19:08 lw Exp $
package team5.casino;

import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NameComponent;

/**
 * ShutdownThread is a small class needed by the Runtime.ShutdownThread
 * method to allow the server to trap a 'kill' signal from the operating
 * system and attempt to cleanly shutdown before exiting.
 * <p>Right now the only thing that the thread attempts to do is to
 * remove the name of the Tables object from the naming service.  We
 * may want to include more actions later on in the project
 *
 * @author Team5
 * @version $Revision: 1.2 $
 *
 */
class ShutdownThread extends Thread {

    NamingContext ncx = null;
    NameComponent[] nc = null;

    /**
     * The empty constructor for the class. We want to have an empty
     * constructor so that the class can be created as soon as possible
     * enven before the naming information is ready to be assigned
     * to the to the member variables
     */
    ShutdownThread() {
    }

    /**
     * This method just allows one to add the Naming context and naming*
     * component to the member variables of the class.
     * @param ncx the Naming Context for the orb.
     * @param nc the name component for the Floor interface.
     */
    public void addName(NamingContext ncx, NameComponent[] nc) {
        this.ncx = ncx;
        this.nc = nc;
    }

    /**
     * This method attempts to remove the Floor interface from the
     * naming service.  This method is called automatically at shutdown
     * the the Runtime object.
     */
    public void run() {
        System.out.println("---Caught kill signal: Shutting down....");
        if (nc != null && ncx != null) {
            System.out.print("---Attempting to remove reference from "
                    + "naming server....");
            try {
                ncx.unbind(nc);
            } catch (Exception e) {
                System.out.println("---Couldn't remove name from service.");
            }
        }
        System.out.println("done.");
    }

}
