// $Id: Table.java,v 1.9 2003/03/15 18:42:48 lw Exp $
package team5.casino;

import java.util.Hashtable;

import team5.casino.db.TableDB;
import team5.casino.db.BankDB;
import team5.casino.comm.PlayerProxy;
import team5.base.game.Card;
import team5.base.comm.SequenceNumber;
import team5.base.comm.InvalidObjectID;
import team5.base.comm.CommException;
import team5.base.UnhandledException;

// TODO: Fix exception handling in this class (see UnhandledException)

/**
 * This class...
 * TODO: Fix comment
 * @author Team 5
 * @version $Revision: 1.9 $
 */
class Table implements Runnable {

    Table(TableDB tableDB, BankDB bankDB, int gameID, Players players) {

        this.tableDB = tableDB;
        this.bankDB = bankDB;
        this.gameID = gameID;
        this.players = players;
        dealerID = 10000 + gameID;	// Assuming dealerID = 10000 + gameID
    }

    static int count = 1;

    public void run() {

        boolean status = true;

        //load player list
        playerIDs = tableDB.getPlayerIDs(gameID);

        try {
            while (playerIDs.length > 0) {

                int gameState = bankDB.getState(playerIDs[0]);

                switch (gameState) {
                    case 1:
                    case 2:
                        //run hand
                        System.out.println("\nTI------------------------------------");
                        System.out.println("\nTI-TABLE#" +
                                gameID + "  STARTS. NO MORE PLAYER ALLOWS UNTIL THE GAME ENDS");

                        // Dealer request the bet from each player
                        status = dealerRequestBets();
                        // FALLTHROUGH
                    case 3:
                        System.out.println("In Table: case 3");

                        int[] playerCards = tableDB.getPlayerCards(playerIDs[0]);

                        if (playerCards.length < 2) {
// Dealer starts the game
                            if (status)
                                dealerStartGame();

                        } // end if( playerCards.length < 2 )
                        System.out.println("Calling distribute cards.........");
                        // Distribute the cards
                        if (status)
                            dealerDistributeCards();

                        System.out.println("Calling ask hit or stay.........");
                        // Ask hit or stay

                        try {
                            if (status)
                                dealerAskHitOrStay();
                        } catch (Exception e) {
                            System.out.println("\n++++Error in hit or stay +++++\n");
                        }
                        // Dealer get the card
                        //if( status )
                        //	dealerScore = dealerGetTheRemainingCard( );

                        System.out.println("dealerWinOrLose ......");

                        // Make decision to win or lose
                        if (status)
                            dealerWinOrLose();
                        //Get player list for next hand.
                        //     if( status )

                        // Reset the game
                        tableDB.resetGame(gameID);

                        playerIDs = tableDB.getPlayerIDs(gameID);
                        // Initialize the cards
                        initializeCard();
                } // end switch
            }
        } catch (Exception e) {
            throw new UnhandledException(e);
        }
        //tableDB.removeGame(gameID); this does not exist.
    }


    /**
     * This method is to decide the win or lose for each player
     * If player wins, it calls the bank to add more chips to player.
     * If player loses, it subtracts chips from player's chip balance.
     */
    private void dealerWinOrLose() {
        BankImpl bankObj = null;
        int playerChipBalance = 0;
        int tempChipBalance = 0;
        PlayerProxy player; //the current player

        int playerScore = 0;
        int dealerScore = 0;

        Integer tempAmount = new Integer(0);

        // Retrieve the current list of player
        // playerIDs = tableDB.getPlayerIDs(gameID);

        try {
            for (int i = 0; (i < playerIDs.length) && (playerIDs[i] > 0); i++) {

                playerScore = getCardValueInHand(playerIDs[i]);

                System.out.println("TI-Player ID " + playerIDs[i] +
                        " has " + playerScore);

                if (playerScore <= 21) {
                    dealerScore = dealerGetTheRemainingCard();
                } // end if( playerScore <= 21 )

                System.out.println("TI-Dealer hand has " + dealerScore);

                try {
// Get bank object
                    bankObj = new BankImpl(bankDB);
                    playerChipBalance =
                            bankObj.getChipBalance(playerIDs[i], SequenceNumber.next());

                } catch (Exception e) {
                    System.out.println("Cannot get the chip balance from BankDB.");
                }

                try {
                    tempAmount = (Integer) betAmount.get(
                            new Integer(playerIDs[i]));

                    System.out.println("TempAmount is " + tempAmount.intValue());
                    betAmount.remove(new Integer(playerIDs[i]));
                } catch (Exception e) {
                    System.out.println("Cannot get the betAmount.");
                }

                // VT
                tempChipBalance = bankObj.getChipBalance(playerIDs[i],
                        SequenceNumber.next());
                System.out.println("\nBefore deciding: Player ID#" + playerIDs[i] +
                        " balance is " + tempChipBalance +
                        " chips.");


                if (((playerScore <= 21) && (playerScore > dealerScore)) ||
                        (dealerScore > 21)) {
                    // Player wins
                    System.out.println("TI-PLAYER ID#" + playerIDs[i] + " WINS");

                    // Add chips to player chips balance
                    // This is done by 'buying' the amount of the bet
                    // TODO: Currently, there is no extra such 1.5 times
                    playerChipBalance += tempAmount.intValue();

                    // VT
                    System.out.println("The chipbalance is " + playerChipBalance +
                            ", tempAmount is " + tempAmount.intValue());

                    try {
                        bankObj.addChips(playerIDs[i], SequenceNumber.next(),
                                tempAmount.intValue());
                    } catch (InvalidObjectID e) {
                        System.out.println("TI-Player ID#" + playerIDs[i] +
                                " is invalid.");
                    } // end try

                    // Notify player of win
                    player = players.get(playerIDs[i]);
                    player.gameOver(true, playerChipBalance);
                } else {
                    // Player loses
                    System.out.println("TI-PLAYER ID#" + playerIDs[i] + " LOSES");

                    // Subtract chips from player chips balance
                    // This is done by 'selling' the amount of the bet
                    // TODO: Currently, there is no extra such 1.5 times
                    playerChipBalance -= tempAmount.intValue();

                    // VT
                    System.out.println("The chipbalance is " + playerChipBalance +
                            ", tempAmount is " + tempAmount.intValue());

                    try {
                        bankObj.sellChips(playerIDs[i], SequenceNumber.next(),
                                tempAmount.intValue());
                    } catch (InvalidObjectID e) {
                        System.out.println("TI-Player ID#" + playerIDs[i] +
                                " is invalid.");
                    } // end try

                    // Notify player of loss
                    player = players.get(playerIDs[i]);
                    player.gameOver(false, playerChipBalance);

                } // end if( playerScore > dealerScore )

                tempChipBalance = bankObj.getChipBalance(playerIDs[i],
                        SequenceNumber.next());
                System.out.println("\nTI-Player ID#" + playerIDs[i] +
                        " balance is " + tempChipBalance +
                        " chips.");
            } // end for
        } catch (Exception e) {
            throw new UnhandledException(e);
        }
        // Reset the state of the player to be 1. It will be the same
        // as the player just finishes the joinTable
        bankDB.setState(playerIDs[0], 2);
        if (bankDB.getState(playerIDs[0]) == 2) {
            System.out.println("Reset the state of the game");
        } // end if( bankDB.getState( playerIDs[0] ) == 2 )

    } // end dealerWinOrLose


    /**
     * This method is to return the value of the given card.
     * Assume that the card number starts from A, 2, 3, ..., K.
     * @param cardNo The card number
     * @return The value of the given card number
     */
    private int cardValue(int cardNo) {

        int value = 0;

        if (cardNo < 40) {
            value = (cardNo / 4) + 1;
        } else {
            value = 10;
        }
        return (value);
    } // end cardValue


    /**
     * This method is to get the remaining card(s) for the dealer.
     * @return The dealer's total score
     */
    private int dealerGetTheRemainingCard() {

        PlayerProxy player;

        // Retrieve the current list of player
//        playerIDs = tableDB.getPlayerIDs(gameID);

        byte cardNo = 0;
        Card tempCard;

        int dealerScore = 0;

        try {
            dealerScore = getCardValueInHand(dealerID);
            System.out.println("GetTheRemainingCard: dealerScore is " + dealerScore); // VT
        } catch (Exception e) {
            System.out.println("Cannot getCardValueInHand for dealer.");
        } // end try

        while (dealerScore < stayBreakPoint) {

            // The first card is received. But it is not sent to other players.
            cardNo = getRandomCard(dealerID);

            System.out.println("Dealer gets card ...");
            tempCard = new Card(cardNo);
            System.out.println("    " + tempCard.getName());

            // Distribute to other players on the table
            for (int i = 0;
                 (i < playerIDs.length) && (playerIDs[i] > 0); i++) {
                // Get the player object
                player = players.get(playerIDs[i]);
                try {
                    player.acceptOthersCard(dealerID, cardNo);
                } catch (CommException e) {
                    throw new UnhandledException(e);
                }
            } // end for

            try {
                dealerScore = getCardValueInHand(dealerID);
                System.out.println("GetTheRemainingCard: dealerScore is " + dealerScore); // VT
            } catch (Exception e) {
                System.out.println("Cannot getCardValueInHand for dealer.");
            } // end try
        }
        dealerSendHiddenCard();
        return (dealerScore);
    } // end dealerGetTheRemainingCard


    /**
     * This method is to allow dealer to send the hidden card
     * in dealer's hand to every players.
     */
    void dealerSendHiddenCard() {

        PlayerProxy player;

        // Retrieve the current list of player
//        playerIDs = tableDB.getPlayerIDs(gameID);


        // Distribute to other players on the table
        for (int j = 0; (j < playerIDs.length) && (playerIDs[j] > 0); j++) {
            // Get the player object
            player = players.get(playerIDs[j]);
            if (dealerHiddenCard != 99) {
                try {

                    // VT: Remove
                    Card tmpCard = new Card((byte) dealerHiddenCard);
                    System.out.println(" Send dealer hidden card: " + tmpCard.getName());

                    player.acceptOthersCard(dealerID, dealerHiddenCard);
                } catch (CommException e) {
                    throw new UnhandledException(e);
                }
            } else {

                // In case that the server dies, it will not have
                // the information about the hidden card. In that
                // case, it will flush all cards in the dealer hand.
                for (int i = 0; i < cardAmount; i++) {
                    if (card[i] == dealerID) {
                        try {
                            player.acceptOthersCard(dealerID, (byte) card[i]);
                        } catch (CommException e) {
                            throw new UnhandledException(e);
                        } // end try

                    } // end if( card[i] == dealerID )

                } // end for
            } // end if( dealerHiddenCard != 99 )
        } // end for
    } // end dealerSendHiddenCard


    /**
     * This method is to calculate the hand value of the given player
     * or dealer id.
     * @param ID The id of the card holder
     * @return The total card value in hand
     */
    private int getCardValueInHand(int ID) {
        int score = 0;

        // Start to sum all card value. But keep all A to be summed last.
        for (int j = 4; j < cardAmount; j++) {
            // If it is the player's card
            if (card[j] == ID) {
                score += cardValue(j);
            } // end if( card[ j ] == ID )
        }

        // Calculate for A value. It can be either 11 or 1.
        for (int j = 0; j < 4; j++) {
            if (card[j] == ID) {
                if (score <= 10) {
                    score += 11;
                } else {
                    score += 1;
                } // end if( score <= 10 )
            } // end if( card[ j ] == ID )
        } // end for
        return (score);
    } // end getCardValueInHand


    /**
     * This method is to ask each player to hit or stay. If player
     * decides to hit, a card will be kept sending. However, the
     * player can hit at most 3 times because each player can hold
     * up to 5 cards at a game.i
     * Assuming that the choice returned from player is HIT when it
     * is 0. 1 is to STAY.
     */
    private void dealerAskHitOrStay() {
        int choice;	// Player choice to hit or stay
        boolean over21 = false;   // True if the card value in player hand is over 21.
        int cardCount;	// The counter of new card when player asks for hit
        byte newCardNo;	// The card no that will be sent to player
        int noCardsSent = 0;
        PlayerProxy player; //the current player
        PlayerProxy otherPlayer; //An other player
        int MaxCardAllowance = 5; //I don't know what this should be.

        // Retrieve the current list of players
        //        playerIDs = tableDB.getPlayerIDs(gameID);

        System.out.println("Inside AskHitOrStay******");


        for (int i = 0;
             (i < playerIDs.length) && (playerIDs[i] > 0); i++) {
            // Get player object from player ID
            player = players.get(playerIDs[i]);
            // Currently, player has 2 cards on the hand
            cardCount = noCardsSent;

            do {
                try {

                    System.out.println("Inside AskHitOrStay: before calling player option. Player ID#" + playerIDs[i] + " **********");
                    choice = player.playerOption();
                    System.out.println("Inside AskHitOrStay: after calling player option ");

                    if (choice == 0) // Assuming 0 is HIT
                    {
                        newCardNo = getRandomCard(playerIDs[i]);
                        player.acceptCard(newCardNo);

                        System.out.println("\nTI-Player ID#" + playerIDs[i] +
                                " chooses to HIT.");
                        System.out.println("TI-The new card is #" +
                                newCardNo);

                        displayDealerCards();

                        // Distribute to other players on the table
                        for (int k = 0;
                             (k < playerIDs.length) && (playerIDs[i] > 0); k++) {
                            // If it is not the current player
                            if (k != i) {
                                // Get the player object
                                otherPlayer = players.get(playerIDs[k]);
                                otherPlayer.acceptOthersCard(playerIDs[i],
                                        newCardNo);
                            } // end if( k != i )
                        } // end for
                        cardCount++;
                    } // end if( choice == 0 )

                    if (getCardValueInHand(playerIDs[i]) > 21) {
                        over21 = true;
                    }
                } catch (CommException e) {
                    throw new UnhandledException(e);
                }

            } while ((choice == 0) &&
                    (cardCount < MaxCardAllowance) &&
                    (over21 == false));

            if (choice == 1) {
                System.out.println("TI-Player ID#" + playerIDs[i] +
                        " chooses to STAY.");
            } // end if( choice == 1 )

            if (cardCount >= MaxCardAllowance) {
                System.out.println("TI-Player ID#" + playerIDs[i] +
                        " is forced to STAY because he/she has " +
                        cardCount + " cards.");
            } // end if( cardCount >= MaxCardAllowance )
        } // end for
    } // end dealerAskHitOrStay


    /**
     * This method is to distribute two cards to each player
     * and dealer. The cards will be randomly picked.
     * Assumptions
     * 1) Only the second card of each player will be sent
     * to other players to display
     */
    private void dealerDistributeCards() {
        // Send only two cards initially
        int noCardsSent = 2;
        byte cardNo;
        PlayerProxy player;

        // Retrieve the current list of player
//        playerIDs = tableDB.getPlayerIDs(gameID);


        // Distribute cards to each player
        for (int i = 0; (i < playerIDs.length) && (playerIDs[i] > 0); i++) {
            System.out.print("TI-Distribute the cards to player ID#" +
                    playerIDs[i] + " : ");

            try {

                int[] playerCards = tableDB.getPlayerCards(playerIDs[i]);

                System.out.println("Inside distributing cards: player ID#" +
                        playerIDs[i] + " has " + playerCards.length + " cards.");

                // In the case that server dies and comes back, it will not
                // redistribute these two cards.
                if (playerCards.length < 2) {
// Get player object from playerID
                    player = players.get(playerIDs[i]);
// The first card is received. But it is not sent to other players.
                    cardNo = getRandomCard(playerIDs[i]);
                    player.acceptCard(cardNo);

                    tableDB.insertCard(gameID, playerIDs[i], cardNo);

                    System.out.print(cardNo + ", ");

// The second card is received. It will be sent to other players.
                    cardNo = getRandomCard(playerIDs[i]);
                    player.acceptCard(cardNo);

                    tableDB.insertCard(gameID, playerIDs[i], cardNo);

                    System.out.println(cardNo);

// Distribute to other players on the table
                    for (int k = 0;
                         (k < playerIDs.length) && (playerIDs[i] > 0); k++) {
// If it is not the current player
                        if (k != i) {
                            player.acceptOthersCard(playerIDs[i],
                                    cardNo);
                        } // end if( k != i )
                    } // end for
                } // end if( playerCards.length < 2 )
            } catch (Exception e) {
                System.out.println("The player ID#" + playerIDs[i] +
                        " is not ready to play.");
            } // end try
        } // end for


        int[] dealerCards = tableDB.getPlayerCards(dealerID);

        if (dealerCards.length < 2) {
// Distribute cards to dealer
            System.out.print("TI-Distribute the card to dealer ID#" +
                    dealerID + " : ");
// The first card is received. But it is not sent to other players.
            cardNo = getRandomCard(dealerID);
            dealerHiddenCard = cardNo;

            tableDB.insertCard(gameID, dealerID, cardNo);

//	    System.out.print( cardNo + ", " );

// The second card is received. It will be sent to other players.
            cardNo = getRandomCard(dealerID);

            tableDB.insertCard(gameID, dealerID, cardNo);

//	    System.out.println( cardNo );

            displayDealerCards();

// Distribute to other players on the table
            for (int i = 0; (i < playerIDs.length) && (playerIDs[i] > 0); i++) {
// Get the player object
                player = players.get(playerIDs[i]);
                try {
                    player.acceptOthersCard(dealerID, cardNo);
                } catch (CommException e) {
                    throw new UnhandledException(e);
                }
            } // end for

// Set the state to be 3
            bankDB.setState(playerIDs[0], 3);
            if (bankDB.getState(playerIDs[0]) == 3) {
                System.out.println("The state is set to be 3");
            } // end if( bankDB.getState( playerIDs[0] ) == 3 )
        } // end if( dealerCards < 2 )
    } // end dealerDistributeCards

    /**
     * This method displays the current list of dealer cards
     */
    private void displayDealerCards() {

        Card tmpCard;

        try {
            // Display all of the cards in Dealer's hand
            System.out.println(" Dealer now has the following cards ...");
            for (int i = 0; i < cardAmount; i++) {
                if (card[i] == dealerID) {
                    tmpCard = new Card((byte) i);
                    System.out.println("   " + " : " + tmpCard.getName());
                } // end if( card[ i ] == dealerID )
            } // end for
        } catch (Exception e) {
            System.out.println("EXCEPTION-DisplayDealerCards: general error");
        }
    } // end displayDealerCards


    /**
     * This method is to get the card randomly. The generated card
     * is not in any players' hand.
     * Assume that the new deck will be used when the new game starts.
     * Therefore, it is not in the case where it runs out of the cards.
     * @param playerID The current player who will get the card
     * @return The card number
     */
    private byte getRandomCard(int playerID) {
        double randomFactor;
        byte randomNumber;
        boolean Ok = false;

        do {
            randomFactor = Math.random();

            // Assume that the card number starts from 0 to 51
            randomNumber = (byte) Math.floor(randomFactor * cardAmount);

            if (card[randomNumber] == 0) {
                card[randomNumber] = playerID;
                Ok = true;
            } // end if( card[ randomNumber ] == 0
        } while (Ok == false); // end do

        return (randomNumber);
    } // end getRandomCard

    /**
     * This method is to start the game on the player side. The
     * method to start the game of each player will be called.
     */
    private void dealerStartGame() {
        PlayerProxy player;

        // Retrieve the current list of player
        playerIDs = tableDB.getPlayerIDs(gameID);

        System.out.println("TI-Dealer starts the game with " +
                playerIDs.length + " players.");

        for (int i = 0;
             (i < playerIDs.length) && (playerIDs[i] > 0); i++) {
            System.out.println("TI-Start the game for player ID#" +
                    playerIDs[i]);

            // Get player object from playerID
            player = players.get(playerIDs[i]);
            try {
                player.startGame((byte) playerIDs.length);
            } catch (CommException e) {
                throw new UnhandledException(e);
            }
        } // end for
    } // end dealerStartRequest


    /**
     * This method is to request the bets from each player. If
     * the player has insufficient bets, he/she has to buy from
     * the bank. Player will have limited time to place the bet.
     * If the time is out, player will be forced to leave the game.
     * @return True if there is at least one valid player. False, if there
     * is no valid player on the game.
     */
    private boolean dealerRequestBets() {
        boolean status = false;

        PlayerProxy player;
        int tempBet = -1;

        // Retrieve the current list of player
//        playerIDs = tableDB.getPlayerIDs(gameID);

        for (int i = 0;
             (i < playerIDs.length) && (playerIDs[i] > 0);
             ++i) {

            System.out.println("TI-Currently, there are " + playerIDs.length +
                    " players.");
            // Get player object from playerID
            player = players.get(playerIDs[i]);

            try {
                System.out.println("TI-" + i + ") Wait for player ID#" +
                        playerIDs[i] + " to place bet");

                tempBet = player.placeBet();

                System.out.println("TI-Receive the placeBet from playerID#" +
                        playerIDs[i]);

                // If the player doesn't bet
                if (tempBet == 0) {
                    status = false;
                    System.out.println("TI-QUIT: Player placed a 0 bet to QUIT");
// NOTE:  This may not work well for multiple clients
                    player.kickOut();
                    tableDB.removePlayer(playerIDs[i]);
                    players.remove(playerIDs[i]);   // Remove from hash
                } else {
                    status = true;
                    tableDB.setBet(playerIDs[i], tempBet);
                    System.out.println("TI-OK: Bet is " + tempBet);
                } // end if( tempBet == 0 )
            } catch (Exception e) {
                System.out.println("TI-Cannot place bet");
                status = false;
            } // end try

            if (status) {
                try {
                    betAmount.put(new Integer(playerIDs[i]),
                            new Integer(tempBet));
                    status = true;
                    tempBet = 0;
                } catch (Exception e) {
                    System.out.println("TI-The bet amount cannot be added.");
                    status = false;
                }
            } // end if( status )

            /* Because the dealerDistributeCards() will be called immediately
            after the player places the bet, the state should be set after
               the dealer distributes the cards.

//            bankDB.setState(playerIDs[i], 3);
//            if (bankDB.getState(playerIDs[i]) == 3) {
//              System.out.println("The state is set to be 3.");
//            } // end if( bankDB.getState( playerIDs[i] ) == 3 )
            */

            // TODO: Next phase, catch exception if the player has
            // timeout exception?

            // TODO: How to sell the chips to player if player has
            // insufficient chips?

        } // end for

        // If there is at least one player place the bet, we can start
        // the game by setting the status to be 1
        if (tableDB.getPlayerIDs(gameID).length > 0) {
            tableDB.setStatus(gameID, 1);
            System.out.println("TI-Set status of game#" + gameID +
                    " to be " + tableDB.getStatus(gameID));
        } else {
            tableDB.setStatus(gameID, 0);
            System.out.println("TI-TablesImpl: reset status of game#" + gameID +
                    " to be " + tableDB.getStatus(gameID));
        } // end if( status )

        return (status);
    } // end dealerRequestBets


    /**
     * This method is to initalize the card possesion to be 0.
     */
    public void initializeCard() {
        System.out.println("TI-New deck is requested.");

        for (int i = 0; i < cardAmount; i++) {
            card[i] = 0;
        } // end for
    } // end initializeCard

    /**
     This method is to set the card ownership.
     */
    public void setCard(int cardID, int ownerID) {
        card[cardID] = ownerID;

        System.out.println("Card ID#" + cardID + " is owned by " + ownerID);
    } // end setCard


    /**
     This convenience method is to allow the TablesImpl to retrieve the bet amount
     from the DB and put in the betAmount data member.
     */
    public void putBetAmount(int playerID, int bet) {
        betAmount.put(new Integer(playerID), new Integer(bet));
    } // end putBetAmount

    // Fields

    /** */
    private TableDB tableDB;

    /** */
    private BankDB bankDB;

    /** */
    private int gameID;

    /** */
    private int[] playerIDs;

    /** */
    private Players players;

    /** */
    private byte dealerHiddenCard = 99;

    /** */
    private int dealerID;

    /** */
    private Hashtable betAmount = new Hashtable();

    /** */
    // Number of card. Currently, assume only one deck
    private int cardAmount = 52;

    /** */
    // Dealer Stay break point
    private int stayBreakPoint = 16;

    /** */
    // The current setting for the bet
    // If card[0] is 12, it is on the hand of player#12
    private int[] card = new int[cardAmount];
}
