package team5.casino.db;

import java.util.*;
import java.io.*;
import java.sql.*;

/**
 * Microsoft SQL Server JDBC test program
 */
public class Test {

    public Test(String user, String password) throws Exception {
        // Get connection
        TableDB table;
        BankDB bank;
        PlayerDB player;
        DataConnection db;
        table = new TableDB(user,password);
        bank = new BankDB(user,password);
        player = new PlayerDB(user,password);
        db = new DataConnection(user,password);
        db.connectDB();
        ResultSet result = null;
        try {
            int i = 0;
            db.modifyQuery("delete from bank where player_id <> '1000'");
            db.modifyQuery("delete from player_hand where game_id <> '1000'");
            db.modifyQuery("delete from game_players where game_id <> '1000'");
            db.modifyQuery("delete from game_table where game_id <> '1000'");
            db.modifyQuery("delete from player_info where player_id <> '1000'");
            db.modifyQuery("update OriginCounter set origin_id = 1 ");
            db.modifyQuery("delete from casino_transaction");
            //get players
            i = player.getNewPlayerID();
            System.out.println("get id =" + i);
            i = player.addPlayer(i, 1,"phil");
            System.out.println("phil's id should be 1, actualID =" + i);
            i = player.addPlayer(i, 1,"phil");
            System.out.println("this should give no error and phil's id actualID =" + i);
            i = player.getNewPlayerID();
            System.out.println("get id =" + i);
            i = player.addPlayer(i,1,"phil");
            System.out.println("this should return -1, duplicate login Name =" + i);
            i = player.addPlayer(2,1,"gene");
            System.out.println("gene's id should be 2, actualID =" + i);

            i = table.getOpenGame(1,2);
            System.out.println("player 1 is in game" + i);
            i = table.getOpenGame(2,2);
            System.out.println("player 2 is in game" + i);
            i = bank.buyChips(1,200,3);
            System.out.println("player 1 is buys chips amount in account" + i);
             i = bank.buyChips(1,200,3);
            System.out.println("player 1 trys to buy chips same transaction buys chips amount in account" + i);
             i = bank.subtractChips(1,50,4);
            System.out.println("player 1 subtract chips same transaction buys chips amount in account" + i);
             i = bank.buyChips(1,50,4);
            System.out.println("player 1 trys to buy chips same transaction buys chips amount in account" + i);
            table.insertCard(3,1,1);
            table.insertCard(3,1,2);
            table.insertCard(3,1,2);
           

            System.out.println("game 2 status is " + i);
            // i = bank.addChips(1,0);
            //System.out.println("player 1 has " + i);
           
            int players[] = new int[5];
            players = table.getPlayerIDs(3);
            for (int j = 0; j < 1; j++) {
                System.out.println("game 3 has player " + players[j]);
            }
            String s = player.getLoginName(1);
            System.out.println("player one's login name is: " + s);
            // bank.removePlayer(1);
            // table.removePlayer(1);
            // player.removePlayer(player.getLoginName(1));
            // table.removePlayer(6);
            // player.removePlayer("priya");

            players = table.getPlayerIDs(4);
            for (int j = 0; j < 1; j++) {
                System.out.println("game 1 has player " + players[j]);
            }

            table.insertCard(4, 2, 12);
            table.insertCard(4, 2, 4);
            table.insertCard(4, 2, 52);
            table.insertCard(4, 2, 23);
            players = table.getPlayerCards(2);
            for (int j = 0; j < 4; j++) {
                System.out.println("player 2 card = " + players[j]);
            }
            player.setMode(1, 100);
            i = player.getMode(1);
            System.out.println("player mode " + i);
            table.setStatus(3, 100);
            i = table.getStatus(1);
            System.out.println("status game 3 = " + i);
            table.resetGame(3);
            players = table.getPlayerCards(3);
           
           
            result = db.selectQuery("select * from player_info");
            // position to first record
            boolean moreRecords = result.next();
            // If there are no records, display a message
            if (!moreRecords) {
            }
            try {
                // get row data
                do {
                    System.out.println(System.currentTimeMillis());
                    System.out.println(result.getString(1) + " , " + result.getString(2) + " , " + result.getString(3));
                } while (result.next());
            } catch (SQLException sqlex) {
                sqlex.printStackTrace();
            }
        } catch (Exception e) {
        }


    } // Test


    public static void main(String args[]) throws Exception {

        Properties props = loadProps(args[0]);

        String user = props.getProperty("database.user");
        String password = props.getProperty("database.password");
        
        Test test = new Test(user, password);

    }
    
    /**
     * Load the properties file from disk.
     * @return a properties object.
     */
    private static Properties loadProps(String propfileName) {
        Properties props = null;
        System.out.println("---Loading properties file: " + propfileName);
        try {
            props = new Properties(System.getProperties());
            props.load(new BufferedInputStream(new FileInputStream(propfileName)));
        } catch (Exception e) {
            System.out.println("Properties file: " + propfileName + " not found");
            System.exit(-1);
        }
        return props;
    }
}
