// $Id: ShutdownThread.java,v 1.2 2003/03/14 13:29:49 lw Exp $
package team5.repman;

import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NameComponent;

/**
 * ShutdownThread is a small class needed by the Runtime.ShutdownThread
 * method to allow the server to trap a 'kill' signal from the operating
 * system and attempt to cleanly shutdown before exiting.
 *
 * @author Team5
 * @version $Revision: 1.2 $
 *
 */
class ShutdownThread extends Thread {

    NamingContext ncx = null;
    NameComponent[] nc = null;

    /**
     * The empty constructor for the class. We want to have an empty
     * constructor so that the class can be created as soon as possible
     * enven before the naming information is ready to be assigned
     * to the to the member variables
     */
    ShutdownThread(Repman repman) {
        this.repman = repman;
    }


    /**
     * This method attempts to remove the Floor interface from the
     * naming service.  This method is called automatically at shutdown
     * the the Runtime object.
     */
    public void run() {
        System.out.println("---Caught kill signal: Shutting down....");
        //do shutdown stuff
        repman.cleanup();
        System.out.println("done.");
    }

    /** The replication manager this thread belongs to. */
    private Repman repman;
}